import appuifw
from key_codes import *

class Keyboard(object):

	def __init__(self,onevent=lambda:None):
		self._keyboard_state={}
		self._downs={}
		self._onevent=onevent

	def handle_event(self,event):
		if event['type'] == appuifw.EEventKeyDown:
			code=event['scancode']
			if not self.is_down(code):
				self._downs[code]=self._downs.get(code,0)+1
			self._keyboard_state[code]=1
		elif event['type'] == appuifw.EEventKeyUp:
			self._keyboard_state[event['scancode']]=0
		self._onevent()

	def is_down(self,scancode):
		return self._keyboard_state.get(scancode,0)

	def pressed(self,scancode):
		if self._downs.get(scancode,0):
			self._downs[scancode]-=1
			return True
		return False

	def pool(self):
		act = []
		if self.is_down(EScancodeLeftArrow) or self.is_down(EScancode4): act.append('ml')
		if self.is_down(EScancodeRightArrow) or self.is_down(EScancode6): act.append('mr')
		if self.is_down(EScancodeDownArrow) or self.is_down(EScancode5): act.append('md')
		if self.is_down(EScancodeUpArrow) or self.is_down(EScancode2): act.append('mu')
		if self.pressed(EScancodeHash): act.append('c')
		#~ if self.pressed(EScancodeStar): act.append('s')
		return act
