import os
from graphics import *

class Rexman:
	_img_dir = 'E:\\Others\\freed0m'
	_img_mask = 'm_%s.png'
	_img_bng = True
	_cache = {}
	_color=_phase = None

	size=(14,16)
	color=0xffffff
	vel=loc=(0,0)
	alt=5
	td=None # Touchdown
	bng=True
	action=None

	def __init__(self):
		self.img = Image.new((14,16))
		self._update()

	def act(self, act):
		if act:
			ac = [0.,0.] # Avatar Contribution
			for atom in act:
				if atom[0] == 'm':
					if not self.action:
						if atom[1] == 'l': ac[0] -= 1
						elif atom[1] == 'r': ac[0] += 1
						elif atom[1] == 'u': ac[1] -= 1
						elif atom[1] == 'd': ac[1] += 1
					else:
						if atom[1] == 'l': self.vel[0] = -abs(self.vel[0])
						elif atom[1] == 'r': self.vel[0] = abs(self.vel[0])
				if atom[0] == 'c':
					if not self.action and self.alt < 4 and abs(self.vel[1]) < 0.3:
						self.action	= 'duck'
						self.vel[0] = self.vel[0] / 10
						self.vel[1] = self.vel[1] / 10
					else: self.action = None
			return ac

	def _update(self, pulse=0):
		vx, vy = self.vel[0], self.vel[1]
		if self.action: phase = self.action
		elif self.alt > 4 or abs(vy) > 0.3:
			phase = 'flight'
			self.td = None
		elif abs(vx) > 0.3:
			try: mp = int(self._phase[1])
			except ValueError: phase = 'm1'
			else:
				if pulse == 0: phase = 'm'+str( mp%4 + 1 )
				else: phase = self._phase
		else: phase = 'still'

		if (self._color != self.color):
			self._color = self.color
			self.img.clear(self.color)

		if (self._phase != phase):
			cc = eval(self.__class__.__name__)
			try: self.msk = cc._cache[phase]
			except KeyError:
				self.msk = Image.new((14,16), '1')
				self.msk.load(os.path.join(self._img_dir, self._img_mask%phase))
				cc._cache[phase] = self.msk
			self.bng = self._img_bng
			self._phase = phase

		if vx != 0 and (vx > 0) != self.bng:
			self.msk = self.msk.transpose(FLIP_LEFT_RIGHT)
			self.bng = (vx > 0)
